<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:11 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>Plugin (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="Plugin (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/gradle/api/PathValidation.html" title="enum in org.gradle.api"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/gradle/api/PolymorphicDomainObjectContainer.html" title="interface in org.gradle.api"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/gradle/api/Plugin.html" target="_top">Frames</a></li>
<li><a href="Plugin.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api</div>
<h2 title="Interface Plugin" class="title">Interface Plugin&lt;T&gt;</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl><dt><span class="strong">Type Parameters:</span></dt><dd><code>T</code> - The type of object which this plugin can configure.</dd></dl>
<dl>
<dt>All Known Implementing Classes:</dt>
<dd>org.gradle.api.plugins.quality.internal.AbstractCodeQualityPlugin, <a href="../../../org/gradle/api/plugins/announce/AnnouncePlugin.html" title="class in org.gradle.api.plugins.announce">AnnouncePlugin</a>, <a href="../../../org/gradle/api/plugins/antlr/AntlrPlugin.html" title="class in org.gradle.api.plugins.antlr">AntlrPlugin</a>, <a href="../../../org/gradle/api/plugins/ApplicationPlugin.html" title="class in org.gradle.api.plugins">ApplicationPlugin</a>, <a href="../../../org/gradle/language/assembler/plugins/AssemblerLangPlugin.html" title="class in org.gradle.language.assembler.plugins">AssemblerLangPlugin</a>, <a href="../../../org/gradle/language/assembler/plugins/AssemblerPlugin.html" title="class in org.gradle.language.assembler.plugins">AssemblerPlugin</a>, <a href="../../../org/gradle/api/plugins/BasePlugin.html" title="class in org.gradle.api.plugins">BasePlugin</a>, <a href="../../../org/gradle/platform/base/plugins/BinaryBasePlugin.html" title="class in org.gradle.platform.base.plugins">BinaryBasePlugin</a>, <a href="../../../org/gradle/api/plugins/announce/BuildAnnouncementsPlugin.html" title="class in org.gradle.api.plugins.announce">BuildAnnouncementsPlugin</a>, <a href="../../../org/gradle/api/reporting/plugins/BuildDashboardPlugin.html" title="class in org.gradle.api.reporting.plugins">BuildDashboardPlugin</a>, <a href="../../../org/gradle/buildinit/plugins/BuildInitPlugin.html" title="class in org.gradle.buildinit.plugins">BuildInitPlugin</a>, <a href="../../../org/gradle/api/plugins/quality/CheckstylePlugin.html" title="class in org.gradle.api.plugins.quality">CheckstylePlugin</a>, <a href="../../../org/gradle/nativeplatform/toolchain/plugins/ClangCompilerPlugin.html" title="class in org.gradle.nativeplatform.toolchain.plugins">ClangCompilerPlugin</a>, <a href="../../../org/gradle/language/c/plugins/CLangPlugin.html" title="class in org.gradle.language.c.plugins">CLangPlugin</a>, <a href="../../../org/gradle/api/plugins/quality/CodeNarcPlugin.html" title="class in org.gradle.api.plugins.quality">CodeNarcPlugin</a>, <a href="../../../org/gradle/plugins/javascript/coffeescript/CoffeeScriptBasePlugin.html" title="class in org.gradle.plugins.javascript.coffeescript">CoffeeScriptBasePlugin</a>, <a href="../../../org/gradle/api/plugins/buildcomparison/gradle/CompareGradleBuildsPlugin.html" title="class in org.gradle.api.plugins.buildcomparison.gradle">CompareGradleBuildsPlugin</a>, <a href="../../../org/gradle/platform/base/plugins/ComponentBasePlugin.html" title="class in org.gradle.platform.base.plugins">ComponentBasePlugin</a>, <a href="../../../org/gradle/language/base/plugins/ComponentModelBasePlugin.html" title="class in org.gradle.language.base.plugins">ComponentModelBasePlugin</a>, <a href="../../../org/gradle/language/c/plugins/CPlugin.html" title="class in org.gradle.language.c.plugins">CPlugin</a>, <a href="../../../org/gradle/language/cpp/plugins/CppBasePlugin.html" title="class in org.gradle.language.cpp.plugins">CppBasePlugin</a>, <a href="../../../org/gradle/language/cpp/plugins/CppExecutablePlugin.html" title="class in org.gradle.language.cpp.plugins">CppExecutablePlugin</a>, <a href="../../../org/gradle/language/cpp/plugins/CppLangPlugin.html" title="class in org.gradle.language.cpp.plugins">CppLangPlugin</a>, <a href="../../../org/gradle/language/cpp/plugins/CppLibraryPlugin.html" title="class in org.gradle.language.cpp.plugins">CppLibraryPlugin</a>, <a href="../../../org/gradle/language/cpp/plugins/CppPlugin.html" title="class in org.gradle.language.cpp.plugins">CppPlugin</a>, <a href="../../../org/gradle/nativeplatform/test/cunit/plugins/CUnitConventionPlugin.html" title="class in org.gradle.nativeplatform.test.cunit.plugins">CUnitConventionPlugin</a>, <a href="../../../org/gradle/nativeplatform/test/cunit/plugins/CUnitPlugin.html" title="class in org.gradle.nativeplatform.test.cunit.plugins">CUnitPlugin</a>, <a href="../../../org/gradle/api/distribution/plugins/DistributionPlugin.html" title="class in org.gradle.api.distribution.plugins">DistributionPlugin</a>, <a href="../../../org/gradle/plugins/ear/EarPlugin.html" title="class in org.gradle.plugins.ear">EarPlugin</a>, <a href="../../../org/gradle/plugins/ide/eclipse/EclipsePlugin.html" title="class in org.gradle.plugins.ide.eclipse">EclipsePlugin</a>, <a href="../../../org/gradle/plugins/ide/eclipse/EclipseWtpPlugin.html" title="class in org.gradle.plugins.ide.eclipse">EclipseWtpPlugin</a>, <a href="../../../org/gradle/plugins/javascript/envjs/EnvJsPlugin.html" title="class in org.gradle.plugins.javascript.envjs">EnvJsPlugin</a>, <a href="../../../org/gradle/api/plugins/quality/FindBugsPlugin.html" title="class in org.gradle.api.plugins.quality">FindBugsPlugin</a>, <a href="../../../org/gradle/nativeplatform/toolchain/plugins/GccCompilerPlugin.html" title="class in org.gradle.nativeplatform.toolchain.plugins">GccCompilerPlugin</a>, <a href="../../../org/gradle/nativeplatform/test/googletest/plugins/GoogleTestConventionPlugin.html" title="class in org.gradle.nativeplatform.test.googletest.plugins">GoogleTestConventionPlugin</a>, <a href="../../../org/gradle/nativeplatform/test/googletest/plugins/GoogleTestPlugin.html" title="class in org.gradle.nativeplatform.test.googletest.plugins">GoogleTestPlugin</a>, <a href="../../../org/gradle/api/plugins/GroovyBasePlugin.html" title="class in org.gradle.api.plugins">GroovyBasePlugin</a>, <a href="../../../org/gradle/api/plugins/GroovyPlugin.html" title="class in org.gradle.api.plugins">GroovyPlugin</a>, <a href="../../../org/gradle/api/plugins/HelpTasksPlugin.html" title="class in org.gradle.api.plugins">HelpTasksPlugin</a>, <a href="../../../org/gradle/plugins/ide/idea/IdeaPlugin.html" title="class in org.gradle.plugins.ide.idea">IdeaPlugin</a>, org.gradle.plugins.ide.internal.IdePlugin, <a href="../../../org/gradle/api/publish/ivy/plugins/IvyPublishPlugin.html" title="class in org.gradle.api.publish.ivy.plugins">IvyPublishPlugin</a>, <a href="../../../org/gradle/testing/jacoco/plugins/JacocoPlugin.html" title="class in org.gradle.testing.jacoco.plugins">JacocoPlugin</a>, <a href="../../../org/gradle/api/plugins/JavaBasePlugin.html" title="class in org.gradle.api.plugins">JavaBasePlugin</a>, <a href="../../../org/gradle/plugin/devel/plugins/JavaGradlePluginPlugin.html" title="class in org.gradle.plugin.devel.plugins">JavaGradlePluginPlugin</a>, <a href="../../../org/gradle/language/java/plugins/JavaLanguagePlugin.html" title="class in org.gradle.language.java.plugins">JavaLanguagePlugin</a>, <a href="../../../org/gradle/api/plugins/JavaLibraryDistributionPlugin.html" title="class in org.gradle.api.plugins">JavaLibraryDistributionPlugin</a>, <a href="../../../org/gradle/api/plugins/JavaLibraryPlugin.html" title="class in org.gradle.api.plugins">JavaLibraryPlugin</a>, <a href="../../../org/gradle/api/plugins/JavaPlugin.html" title="class in org.gradle.api.plugins">JavaPlugin</a>, <a href="../../../org/gradle/plugins/javascript/base/JavaScriptBasePlugin.html" title="class in org.gradle.plugins.javascript.base">JavaScriptBasePlugin</a>, <a href="../../../org/gradle/api/plugins/quality/JDependPlugin.html" title="class in org.gradle.api.plugins.quality">JDependPlugin</a>, <a href="../../../org/gradle/plugins/javascript/jshint/JsHintPlugin.html" title="class in org.gradle.plugins.javascript.jshint">JsHintPlugin</a>, <a href="../../../org/gradle/jvm/plugins/JUnitTestSuitePlugin.html" title="class in org.gradle.jvm.plugins">JUnitTestSuitePlugin</a>, <a href="../../../org/gradle/jvm/plugins/JvmComponentPlugin.html" title="class in org.gradle.jvm.plugins">JvmComponentPlugin</a>, <a href="../../../org/gradle/language/jvm/plugins/JvmResourcesPlugin.html" title="class in org.gradle.language.jvm.plugins">JvmResourcesPlugin</a>, <a href="../../../org/gradle/language/base/plugins/LanguageBasePlugin.html" title="class in org.gradle.language.base.plugins">LanguageBasePlugin</a>, <a href="../../../org/gradle/language/base/plugins/LifecycleBasePlugin.html" title="class in org.gradle.language.base.plugins">LifecycleBasePlugin</a>, <a href="../../../org/gradle/api/plugins/MavenPlugin.html" title="class in org.gradle.api.plugins">MavenPlugin</a>, <a href="../../../org/gradle/api/publish/maven/plugins/MavenPublishPlugin.html" title="class in org.gradle.api.publish.maven.plugins">MavenPublishPlugin</a>, <a href="../../../org/gradle/nativeplatform/toolchain/plugins/MicrosoftVisualCppCompilerPlugin.html" title="class in org.gradle.nativeplatform.toolchain.plugins">MicrosoftVisualCppCompilerPlugin</a>, <a href="../../../org/gradle/nativeplatform/test/plugins/NativeBinariesTestPlugin.html" title="class in org.gradle.nativeplatform.test.plugins">NativeBinariesTestPlugin</a>, <a href="../../../org/gradle/nativeplatform/plugins/NativeComponentModelPlugin.html" title="class in org.gradle.nativeplatform.plugins">NativeComponentModelPlugin</a>, <a href="../../../org/gradle/nativeplatform/plugins/NativeComponentPlugin.html" title="class in org.gradle.nativeplatform.plugins">NativeComponentPlugin</a>, <a href="../../../org/gradle/language/objectivec/plugins/ObjectiveCLangPlugin.html" title="class in org.gradle.language.objectivec.plugins">ObjectiveCLangPlugin</a>, <a href="../../../org/gradle/language/objectivec/plugins/ObjectiveCPlugin.html" title="class in org.gradle.language.objectivec.plugins">ObjectiveCPlugin</a>, <a href="../../../org/gradle/language/objectivecpp/plugins/ObjectiveCppLangPlugin.html" title="class in org.gradle.language.objectivecpp.plugins">ObjectiveCppLangPlugin</a>, <a href="../../../org/gradle/language/objectivecpp/plugins/ObjectiveCppPlugin.html" title="class in org.gradle.language.objectivecpp.plugins">ObjectiveCppPlugin</a>, <a href="../../../org/gradle/api/plugins/osgi/OsgiPlugin.html" title="class in org.gradle.api.plugins.osgi">OsgiPlugin</a>, <a href="../../../org/gradle/play/plugins/PlayApplicationPlugin.html" title="class in org.gradle.play.plugins">PlayApplicationPlugin</a>, <a href="../../../org/gradle/play/plugins/PlayCoffeeScriptPlugin.html" title="class in org.gradle.play.plugins">PlayCoffeeScriptPlugin</a>, <a href="../../../org/gradle/play/plugins/ide/PlayIdePlugin.html" title="class in org.gradle.play.plugins.ide">PlayIdePlugin</a>, <a href="../../../org/gradle/play/plugins/PlayJavaScriptPlugin.html" title="class in org.gradle.play.plugins">PlayJavaScriptPlugin</a>, <a href="../../../org/gradle/play/plugins/PlayPlugin.html" title="class in org.gradle.play.plugins">PlayPlugin</a>, <a href="../../../org/gradle/api/plugins/quality/PmdPlugin.html" title="class in org.gradle.api.plugins.quality">PmdPlugin</a>, <a href="../../../org/gradle/api/plugins/ProjectReportsPlugin.html" title="class in org.gradle.api.plugins">ProjectReportsPlugin</a>, <a href="../../../org/gradle/api/publish/plugins/PublishingPlugin.html" title="class in org.gradle.api.publish.plugins">PublishingPlugin</a>, <a href="../../../org/gradle/api/plugins/ReportingBasePlugin.html" title="class in org.gradle.api.plugins">ReportingBasePlugin</a>, <a href="../../../org/gradle/plugins/javascript/rhino/RhinoPlugin.html" title="class in org.gradle.plugins.javascript.rhino">RhinoPlugin</a>, <a href="../../../org/gradle/api/plugins/scala/ScalaBasePlugin.html" title="class in org.gradle.api.plugins.scala">ScalaBasePlugin</a>, <a href="../../../org/gradle/language/scala/plugins/ScalaLanguagePlugin.html" title="class in org.gradle.language.scala.plugins">ScalaLanguagePlugin</a>, <a href="../../../org/gradle/api/plugins/scala/ScalaPlugin.html" title="class in org.gradle.api.plugins.scala">ScalaPlugin</a>, <a href="../../../org/gradle/plugins/signing/SigningPlugin.html" title="class in org.gradle.plugins.signing">SigningPlugin</a>, <a href="../../../org/gradle/language/swift/plugins/SwiftBasePlugin.html" title="class in org.gradle.language.swift.plugins">SwiftBasePlugin</a>, <a href="../../../org/gradle/nativeplatform/toolchain/plugins/SwiftCompilerPlugin.html" title="class in org.gradle.nativeplatform.toolchain.plugins">SwiftCompilerPlugin</a>, <a href="../../../org/gradle/language/swift/plugins/SwiftExecutablePlugin.html" title="class in org.gradle.language.swift.plugins">SwiftExecutablePlugin</a>, <a href="../../../org/gradle/language/swift/plugins/SwiftLibraryPlugin.html" title="class in org.gradle.language.swift.plugins">SwiftLibraryPlugin</a>, <a href="../../../org/gradle/testing/base/plugins/TestingModelBasePlugin.html" title="class in org.gradle.testing.base.plugins">TestingModelBasePlugin</a>, <a href="../../../org/gradle/ide/visualstudio/plugins/VisualStudioPlugin.html" title="class in org.gradle.ide.visualstudio.plugins">VisualStudioPlugin</a>, <a href="../../../org/gradle/api/plugins/WarPlugin.html" title="class in org.gradle.api.plugins">WarPlugin</a>, <a href="../../../org/gradle/language/rc/plugins/WindowsResourceScriptPlugin.html" title="class in org.gradle.language.rc.plugins">WindowsResourceScriptPlugin</a>, <a href="../../../org/gradle/language/rc/plugins/WindowsResourcesPlugin.html" title="class in org.gradle.language.rc.plugins">WindowsResourcesPlugin</a>, <a href="../../../org/gradle/buildinit/plugins/WrapperPlugin.html" title="class in org.gradle.buildinit.plugins">WrapperPlugin</a>, <a href="../../../org/gradle/ide/xcode/plugins/XcodePlugin.html" title="class in org.gradle.ide.xcode.plugins">XcodePlugin</a>, <a href="../../../org/gradle/nativeplatform/test/xctest/plugins/XCTestConventionPlugin.html" title="class in org.gradle.nativeplatform.test.xctest.plugins">XCTestConventionPlugin</a></dd>
</dl>
<hr>
<br>
<pre>public interface <span class="strong">Plugin&lt;T&gt;</span></pre>
<div class="block"><p>A <code>Plugin</code> represents an extension to Gradle. A plugin applies some configuration to a target object.
 Usually, this target object is a <a href="../../../org/gradle/api/Project.html" title="interface in org.gradle.api"><code>Project</code></a>, but plugins can be applied to any type of
 objects.</p></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../org/gradle/api/Plugin.html#apply(T)">apply</a></strong>(<a href="../../../org/gradle/api/Plugin.html" title="type parameter in Plugin">T</a>&nbsp;target)</code>
<div class="block">Apply this plugin to the given target object.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="apply(java.lang.Object)">
<!--   -->
</a><a name="apply(T)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>apply</h4>
<pre>void&nbsp;apply(<a href="../../../org/gradle/api/Plugin.html" title="type parameter in Plugin">T</a>&nbsp;target)</pre>
<div class="block">Apply this plugin to the given target object.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>target</code> - The target object</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/gradle/api/PathValidation.html" title="enum in org.gradle.api"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/gradle/api/PolymorphicDomainObjectContainer.html" title="interface in org.gradle.api"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/gradle/api/Plugin.html" target="_top">Frames</a></li>
<li><a href="Plugin.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
